## DO NOT EDIT!  Generated automatically from src/libieeep1788_tests_set.itl
## by the Interval Testing Framework for IEEE 1788.
## https://github.com/nehmeier/ITF1788/tree/d06d35fa8a3575e5b19a50db72ecfb4c1d64be14
##
## Copyright 2013 - 2015 Marco Nehmeier (nehmeier@informatik.uni-wuerzburg.de)
## Copyright 2015 Oliver Heimlich (oheim@posteo.de)
## 
## Original author: Marco Nehmeier (unit tests in libieeep1788)
## Converted into portable ITL format by Oliver Heimlich with minor corrections.
## 
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
## 
##     http://www.apache.org/licenses/LICENSE-2.0
## 
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
%!#Test library imports
%!function s = to_string (x)
%!    if (isnumeric (x))
%!        s = num2str (x);
%!    elseif (isa (x, 'infsup'))
%!        s = intervaltotext (x);
%!    elseif (isa (x, 'intval'))
%!        s = disp_ (x);
%!    else
%!        # x probably is a char.
%!        s = x;
%!    endif
%!endfunction

%!#Arithmetic library imports
%!function n = decval (dec)
%!    n = find (strcmp (dec, {"ill", "trv", "def", "dac", "com"}));
%!endfunction

%!#Preamble

## minimal_intersection_test

%!test
%! assert (all (eq (...
%!    and (infsup (1.0, 3.0), infsup (2.1, 4.0)), ...
%!    infsup (2.1, 3.0))))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) & infsup (2.1, 4.0), ...
%!    infsup (2.1, 3.0))))
%!test
%! assert (all (eq (...
%!    and (infsup (1.0, 3.0), infsup (3.0, 4.0)), ...
%!    infsup (3.0, 3.0))))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) & infsup (3.0, 4.0), ...
%!    infsup (3.0, 3.0))))
%!test
%! assert (all (eq (...
%!    and (infsup (1.0, 3.0), infsup), ...
%!    infsup)))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) & infsup, ...
%!    infsup)))
%!test
%! assert (all (eq (...
%!    and (infsup (-inf, inf), infsup), ...
%!    infsup)))
%! assert (all (eq (...
%!    infsup (-inf, inf) & infsup, ...
%!    infsup)))
%!test
%! assert (all (eq (...
%!    and (infsup (1.0, 3.0), infsup (-inf, inf)), ...
%!    infsup (1.0, 3.0))))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) & infsup (-inf, inf), ...
%!    infsup (1.0, 3.0))))

## minimal_intersection_dec_test

%!test
%! assert (all (eq (...
%!    and (infsupdec (1.0, 3.0, "com"), infsupdec (2.1, 4.0, "com")), ...
%!    infsupdec (2.1, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (and (infsupdec (1.0, 3.0, "com"), infsupdec (2.1, 4.0, "com"))) {1}, ...
%!    decorationpart (infsupdec (2.1, 3.0, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "com") & infsupdec (2.1, 4.0, "com"), ...
%!    infsupdec (2.1, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "com") & infsupdec (2.1, 4.0, "com")) {1}, ...
%!    decorationpart (infsupdec (2.1, 3.0, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    and (infsupdec (1.0, 3.0, "dac"), infsupdec (3.0, 4.0, "def")), ...
%!    infsupdec (3.0, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (and (infsupdec (1.0, 3.0, "dac"), infsupdec (3.0, 4.0, "def"))) {1}, ...
%!    decorationpart (infsupdec (3.0, 3.0, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "dac") & infsupdec (3.0, 4.0, "def"), ...
%!    infsupdec (3.0, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "dac") & infsupdec (3.0, 4.0, "def")) {1}, ...
%!    decorationpart (infsupdec (3.0, 3.0, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    and (infsupdec (1.0, 3.0, "def"), infsupdec (empty, "trv")), ...
%!    infsupdec (empty, "trv"))))
%! assert (all (eq (...
%!    decorationpart (and (infsupdec (1.0, 3.0, "def"), infsupdec (empty, "trv"))) {1}, ...
%!    decorationpart (infsupdec (empty, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "def") & infsupdec (empty, "trv"), ...
%!    infsupdec (empty, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "def") & infsupdec (empty, "trv")) {1}, ...
%!    decorationpart (infsupdec (empty, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    and (infsupdec (entire, "def"), infsupdec (empty, "trv")), ...
%!    infsupdec (empty, "trv"))))
%! assert (all (eq (...
%!    decorationpart (and (infsupdec (entire, "def"), infsupdec (empty, "trv"))) {1}, ...
%!    decorationpart (infsupdec (empty, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (entire, "def") & infsupdec (empty, "trv"), ...
%!    infsupdec (empty, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (entire, "def") & infsupdec (empty, "trv")) {1}, ...
%!    decorationpart (infsupdec (empty, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    and (infsupdec (1.0, 3.0, "dac"), infsupdec (entire, "def")), ...
%!    infsupdec (1.0, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (and (infsupdec (1.0, 3.0, "dac"), infsupdec (entire, "def"))) {1}, ...
%!    decorationpart (infsupdec (1.0, 3.0, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "dac") & infsupdec (entire, "def"), ...
%!    infsupdec (1.0, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "dac") & infsupdec (entire, "def")) {1}, ...
%!    decorationpart (infsupdec (1.0, 3.0, "trv")) {1})))

## minimal_convexHull_test

%!test
%! assert (all (eq (...
%!    or (infsup (1.0, 3.0), infsup (2.1, 4.0)), ...
%!    infsup (1.0, 4.0))))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) | infsup (2.1, 4.0), ...
%!    infsup (1.0, 4.0))))
%!test
%! assert (all (eq (...
%!    or (infsup (1.0, 1.0), infsup (2.1, 4.0)), ...
%!    infsup (1.0, 4.0))))
%! assert (all (eq (...
%!    infsup (1.0, 1.0) | infsup (2.1, 4.0), ...
%!    infsup (1.0, 4.0))))
%!test
%! assert (all (eq (...
%!    or (infsup (1.0, 3.0), infsup), ...
%!    infsup (1.0, 3.0))))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) | infsup, ...
%!    infsup (1.0, 3.0))))
%!test
%! assert (all (eq (...
%!    or (infsup, infsup), ...
%!    infsup)))
%! assert (all (eq (...
%!    infsup | infsup, ...
%!    infsup)))
%!test
%! assert (all (eq (...
%!    or (infsup (1.0, 3.0), infsup (-inf, inf)), ...
%!    infsup (-inf, inf))))
%! assert (all (eq (...
%!    infsup (1.0, 3.0) | infsup (-inf, inf), ...
%!    infsup (-inf, inf))))

## minimal_convexHull_dec_test

%!test
%! assert (all (eq (...
%!    or (infsupdec (1.0, 3.0, "trv"), infsupdec (2.1, 4.0, "trv")), ...
%!    infsupdec (1.0, 4.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (or (infsupdec (1.0, 3.0, "trv"), infsupdec (2.1, 4.0, "trv"))) {1}, ...
%!    decorationpart (infsupdec (1.0, 4.0, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "trv") | infsupdec (2.1, 4.0, "trv"), ...
%!    infsupdec (1.0, 4.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "trv") | infsupdec (2.1, 4.0, "trv")) {1}, ...
%!    decorationpart (infsupdec (1.0, 4.0, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    or (infsupdec (1.0, 1.0, "trv"), infsupdec (2.1, 4.0, "trv")), ...
%!    infsupdec (1.0, 4.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (or (infsupdec (1.0, 1.0, "trv"), infsupdec (2.1, 4.0, "trv"))) {1}, ...
%!    decorationpart (infsupdec (1.0, 4.0, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 1.0, "trv") | infsupdec (2.1, 4.0, "trv"), ...
%!    infsupdec (1.0, 4.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 1.0, "trv") | infsupdec (2.1, 4.0, "trv")) {1}, ...
%!    decorationpart (infsupdec (1.0, 4.0, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    or (infsupdec (1.0, 3.0, "trv"), infsupdec (empty, "trv")), ...
%!    infsupdec (1.0, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (or (infsupdec (1.0, 3.0, "trv"), infsupdec (empty, "trv"))) {1}, ...
%!    decorationpart (infsupdec (1.0, 3.0, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "trv") | infsupdec (empty, "trv"), ...
%!    infsupdec (1.0, 3.0, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "trv") | infsupdec (empty, "trv")) {1}, ...
%!    decorationpart (infsupdec (1.0, 3.0, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    or (infsupdec (empty, "trv"), infsupdec (empty, "trv")), ...
%!    infsupdec (empty, "trv"))))
%! assert (all (eq (...
%!    decorationpart (or (infsupdec (empty, "trv"), infsupdec (empty, "trv"))) {1}, ...
%!    decorationpart (infsupdec (empty, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (empty, "trv") | infsupdec (empty, "trv"), ...
%!    infsupdec (empty, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (empty, "trv") | infsupdec (empty, "trv")) {1}, ...
%!    decorationpart (infsupdec (empty, "trv")) {1})))
%!test
%! assert (all (eq (...
%!    or (infsupdec (1.0, 3.0, "trv"), infsupdec (entire, "def")), ...
%!    infsupdec (entire, "trv"))))
%! assert (all (eq (...
%!    decorationpart (or (infsupdec (1.0, 3.0, "trv"), infsupdec (entire, "def"))) {1}, ...
%!    decorationpart (infsupdec (entire, "trv")) {1})))
%! assert (all (eq (...
%!    infsupdec (1.0, 3.0, "trv") | infsupdec (entire, "def"), ...
%!    infsupdec (entire, "trv"))))
%! assert (all (eq (...
%!    decorationpart (infsupdec (1.0, 3.0, "trv") | infsupdec (entire, "def")) {1}, ...
%!    decorationpart (infsupdec (entire, "trv")) {1})))
